package cn.lttc.modules.lttcsamplescan.controller;

import cn.dev33.satoken.annotation.SaIgnore;
import cn.dev33.satoken.util.SaResult;
import cn.lttc.modules.lttcsamplescan.service.ISampleScanService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Iterator;


/**
 * @Description: 样品扫描网络API
 * @Author: GDW
 * @Date: 2024-01-24
 * @Version: V1.0
 */
@RestController
@RequestMapping("/samplescan/api")
public class SampleScanController {
    private final static Logger logger = LoggerFactory.getLogger(SampleScanController.class);
    @Resource
    ISampleScanService sampleScanService;

    @GetMapping("/receive")
    public String Receive(HttpServletRequest request) {
        return "OK";
    }

    @PostMapping("/input")
    @Transactional
    public SaResult uploadProjectFile(HttpServletRequest request) {
        CommonsMultipartResolver commonsMultipartResolver = new CommonsMultipartResolver(request.getSession().getServletContext());
        commonsMultipartResolver.setDefaultEncoding("utf-8");
        MultipartHttpServletRequest mulReq = (MultipartHttpServletRequest) request;
        writeLog(mulReq);
        String uid = sampleScanService.saveData(mulReq);
        JSONObject jsonObject = JSON.parseObject("{'uid' : '" + uid + "'}");
        return SaResult.data(jsonObject);
    }

    @GetMapping("/getimg/{year}/{month}/{filename}")
    ResponseEntity<byte[]> getImg(@PathVariable String year, @PathVariable String month, @PathVariable String filename) {

        ResponseEntity<byte[]> imgService = sampleScanService.getImgService(year, month, filename);

        return imgService;

    }

    synchronized void writeLog(MultipartHttpServletRequest mulReq) {
        String mainJson = mulReq.getParameter("main");
        String detailJson = mulReq.getParameter("detail");
        Iterator<String> fileNames = mulReq.getFileNames();
        int num = 0;
        while (fileNames.hasNext()) {
            fileNames.next();
            num++;
        }
        logger.info("main json: "+ mainJson);
        logger.info("detail json: "+ detailJson);
        logger.info("image num: " + num);
    }
}
