package cn.lttc.modules.sysuser.controller;

import cn.dev33.satoken.session.SaSession;
import cn.dev33.satoken.stp.StpUtil;
import cn.dev33.satoken.util.SaResult;
import cn.lttc.modules.sysuser.entity.User;
import cn.lttc.modules.sysuser.service.SysUserService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Scanner;

@RestController
@RequestMapping("/samplescan/user")
public class SysUser {

    @Resource
    SysUserService sysUserService;

    @PostMapping("/login")
    public SaResult doLogin(@RequestBody User loginUser){

        if (loginUser.getUsername().isBlank() || loginUser.getPassword().isBlank()){
            return SaResult.error("用户名或密码为空");
        }
        User userById = sysUserService.getUserByUsername(loginUser.getUsername());
        if (userById == null || !userById.getPassword().equals(loginUser.getPassword())){
            return SaResult.error("用户名或密码错误");
        }

        StpUtil.login(loginUser.getUsername());
        SaSession tokenSession = StpUtil.getTokenSession();
        return new SaResult(200, "ok", tokenSession.getToken());

//        String userJson = loadResource("/user.json");
//        List<User> list = JSON.parseObject(userJson, new TypeReference<>() {});
//
//        for (User user : list) {
//            if(loginUser.getUsername().equals(user.getUsername())){
//                if (!loginUser.getPassword().equals(user.getPassword())){
//                    return SaResult.error("登录失败");
//                } else {
//
//                }
//            }
//        }
//        return SaResult.error("用户名不存在");
    }

//    public static String loadResource(String resourcePath) throws IOException {
//        try (InputStream inputStream = SysUser.class.getResourceAsStream(resourcePath); Scanner scanner = new Scanner(inputStream, StandardCharsets.UTF_8)) {
//            StringBuilder content = new StringBuilder();
//            while (scanner.hasNextLine()) {
//                content.append(scanner.nextLine());
//            }
//            return content.toString();
//        }
//    }

    @PostMapping("/logout")
    public SaResult logout() {
        StpUtil.logout();
        return SaResult.ok();
    }

    @PostMapping("/adduser")
    public SaResult addUser(@RequestBody User user){
        User userById = sysUserService.getUserByUsername(user.getUsername());
        if (userById!= null){
            return SaResult.error("用户名已存在");
        }
        SaResult addResult = sysUserService.add(user);
        return addResult;
    }
}
